/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */


/*! *****************************************************************************
Copyright (c) 2018 - 2022 Zhou Dengxiang. All rights reserved.
***************************************************************************** */



/// <reference no-default-lib="true"/>


interface ProxyHandler/*;代理处理器*/<T extends object> {
    apply/*;应用*/?(target: T, thisArg: any, argArray: any[]): any;
    construct/*;构造*/?(target: T, argArray: any[], newTarget: Function): object;
    defineProperty/*;定义属性*/?(target: T, p: string | symbol, attributes: PropertyDescriptor): boolean;
    deleteProperty/*;删除属性*/?(target: T, p: string | symbol): boolean;
    get/*;取*/?(target: T, p: string | symbol, receiver: any): any;
    getOwnPropertyDescriptor/*;获取本身属性描述符*/?(target: T, p: string | symbol): PropertyDescriptor | undefined;
    getPrototypeOf/*;获取原型*/?(target: T): object | null;
    has/*;有*/?(target: T, p: string | symbol): boolean;
    isExtensible/*;是可扩展*/?(target: T): boolean;
    ownKeys/*;本身键集*/?(target: T): ArrayLike<string | symbol>;
    preventExtensions/*;阻止扩展*/?(target: T): boolean;
    set/*;置*/?(target: T, p: string | symbol, value: any, receiver: any): boolean;
    setPrototypeOf/*;设置原型*/?(target: T, v: object | null): boolean;
}

interface ProxyConstructor/*;代理构造器*/ {
    revocable/*;可取消*/<T extends object>(target: T, handler: ProxyHandler<T>): { proxy: T; revoke: () => void; };
    new <T extends object>(target: T, handler: ProxyHandler<T>): T;
}
declare var Proxy/*;代理*/: ProxyConstructor;
