"use strict";
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/
Object.defineProperty(exports, "__esModule", { value: true });
exports.registerBaseCommands = void 0;
const configurePlugin_1 = require("./configurePlugin");
const goToProjectConfiguration_1 = require("./goToProjectConfiguration");
const learnMoreAboutRefactorings_1 = require("./learnMoreAboutRefactorings");
const openTsServerLog_1 = require("./openTsServerLog");
const reloadProject_1 = require("./reloadProject");
const restartTsServer_1 = require("./restartTsServer");
const selectTypeScriptVersion_1 = require("./selectTypeScriptVersion");
const makeToJs_1 = require("./makeToJs");
function registerBaseCommands(commandManager, lazyClientHost, pluginManager) {
    commandManager.register(new reloadProject_1.ReloadTypeScriptProjectsCommand(lazyClientHost));
    // commandManager.register(new ReloadJavaScriptProjectsCommand(lazyClientHost));
    commandManager.register(new selectTypeScriptVersion_1.SelectTypeScriptVersionCommand(lazyClientHost));
    commandManager.register(new openTsServerLog_1.OpenTsServerLogCommand(lazyClientHost));
    commandManager.register(new restartTsServer_1.RestartTsServerCommand(lazyClientHost));
    commandManager.register(new goToProjectConfiguration_1.TypeScriptGoToProjectConfigCommand(lazyClientHost));
    // commandManager.register(new JavaScriptGoToProjectConfigCommand(lazyClientHost));
    commandManager.register(new configurePlugin_1.ConfigurePluginCommand(pluginManager));
    commandManager.register(new learnMoreAboutRefactorings_1.LearnMoreAboutRefactoringsCommand());
    commandManager.register(new makeToJs_1.MakeToJsCommand());
    commandManager.register(new makeToJs_1.MakeToJsonCommand());
}
exports.registerBaseCommands = registerBaseCommands;
//# sourceMappingURL=index.js.map