import * as nodes from '../parser/cssNodes';
import { TextDocument, Position, Hover, ClientCapabilities, HoverSettings } from '../cssLanguageTypes';
import { CSSDataManager } from '../languageFacts/dataManager';
export declare class CSSHover {
    private readonly clientCapabilities;
    private readonly cssDataManager;
    private supportsMarkdown;
    private readonly selectorPrinting;
    private defaultSettings?;
    constructor(clientCapabilities: ClientCapabilities | undefined, cssDataManager: CSSDataManager);
    configure(settings: HoverSettings | undefined): void;
    doHover(document: TextDocument, position: Position, stylesheet: nodes.Stylesheet, settings?: HoverSettings | undefined): Hover | null;
    private convertContents;
    private doesSupportMarkdown;
}
